//Programma.c
#include <stdlib.h>
#include <malloc.h>
#include <stdbool.h>
#include <string.h>
#include <stdio.h>
#include "include/list_lib.h"
#include "include/file_lib.h"
#include "include/perceptron_lib.h"
#include "include/main_lib.h"
#include "include/voted_lib.h"
#include "include/voted_list_lib.h"

//max nmber of parameter passed to our program
#define N_ARGUMENTS 10


//default parameter
#define ADABOOST false
#define KERNEL_ALGORITM polinomial
#define POLINOMIAL_DEGREE 2
#define GAUSSIAN_C 3
#define EPOCS 2
#define PATH_TS "Data/Test_set"
#define PATH_TR "Data/Training_set"
#define LOAD_LIST false
#define DIGIT 0
#define VOTED 0

#define MAX_CHAR_NUMBER 4
#define MAX_PATH_SIZE 400


bool adaboost= ADABOOST;
t_kernel kernel_algoritm= KERNEL_ALGORITM;		//type of kernel funciton
float polinomial_degree= POLINOMIAL_DEGREE;		//polonomial degree
float gaussian_c= GAUSSIAN_C;				//gaussian constant
unsigned epocs= EPOCS;					//number of epocs
char *test_set = PATH_TS;				//path of the file containing the test set
char *training_set = PATH_TR;				//path of the file containing the taring set
bool load_list= LOAD_LIST;				//true if I want to load the list from a file
char *list = NULL;					//this contain the path of a file containing a list saved
unsigned digit=DIGIT;					//this is digit chosen
bool voted=VOTED;


//Global variables

//they are the pointer to the matrix
float **tr_set,**ts_set;

//trainig end test dimension
struct dimension dim_tr,dim_ts;

//this is the pointer to the list 's head
t_list_head *head;

//the statistics error
float training_error,test_error;

//indicate if there is a bad parameter
bool is_error=false;

//container of the possible parameter
char arguments[N_ARGUMENTS][MAX_CHAR_NUMBER]={"-a","-c","-d","-dg","-e","-k","-l","-tr","-ts","-vot"};

//create the structure that will correspond to the kernel function selected
struct kernel_record  ker;

//help me to uderstand user answer
char control;

//it's a buffer contain the path where the user want to save the path
char list_save_path[MAX_PATH_SIZE];


int main(int argc ,char *argv[] )
{
	
	
	//index
	unsigned j,i;
	
	//Wrong parameters' number control
	if (!(argc%2) /*|| argc == 1*/ )// commentato argc ==1 perch voglio farlo partire con i valori di default
					//e non c' ancora l'opzione che fa parire i valori di default
	{
		help(argv[0]);
		return EXIT_SUCCESS;
	}

	//Set variables using program's parameters
	for(i=1;i<argc;i+=2)
	{
		for(j=0;j<N_ARGUMENTS;++j)
		{

			if (!strcmp(argv[i],arguments[j]))
			{
				is_error=false;
				//Set variable
				
				if (set_variable(arguments[j],argv[i+1]) == EXIT_FAILURE)
				{
					help(argv[0]);
					return EXIT_SUCCESS;
				}
				break;
			}
			else
				is_error=true;
		}

		if (is_error)
		{
			help(argv[0]);
			return EXIT_SUCCESS;

		}
	}


	
	if(voted)
	{
		printf("Starting training for %u digit ",digit);
		printf ("with voted perceptron algoritm ");
		printf("for %u epocs \n",epocs);
		if (voted_perceptron()==-1)
			return EXIT_FAILURE;

		return EXIT_SUCCESS;
	}
	
	else if (adaboost)
	{
		
		return EXIT_SUCCESS;
	}	

	if (kernel()==-1)
		return EXIT_FAILURE;


	return EXIT_SUCCESS;

}

int kernel(void)
{	
	unsigned i;	
	
	printf("Starting training for %u digit ",digit);

	if(kernel_algoritm==polinomial && !voted)
	{
		printf("with polinomial kernel of %d degree ",(int)polinomial_degree);
		ker.parameter=polinomial_degree;
		ker.kernel_function=polinomial;
	}

	if(kernel_algoritm==gaussian && !voted)
	{
		printf("with gaussian kernel and %d as constant ",(int)gaussian_c);
		ker.parameter=gaussian_c;
		ker.kernel_function=gaussian;
	}
	printf("for %u epocs \n",epocs);
	
	if(load_list)
	printf("List loaded from %s\n",list);
	else
	printf("Training set loaded from %s\n",training_set);

	printf("Test loaded from %s\n",test_set);

	//line counter count the line in the file
       line_counter(training_set,&dim_tr);
       printf("Training set dimension are %ux%u\n",dim_tr.n_rows,dim_tr.n_cols);

       //create a matrix from the training set file
       read_file(&tr_set,dim_tr,training_set);

	if(!load_list)
	{

	//start training
	run(epocs,digit,ker,&head,tr_set,dim_tr,&training_error);
	printf ("End training with %f%% error\n",training_error*100);


	printf("Do you want to save the list? [y|n] \n");
		//save the list
		while( control!='y' && control!='n')
		scanf("%c",&control);


		if(control =='y')
		{
		printf("Save file as :");
                 //this read the first char that is a 10 that interrupt the fgets
                while(control!=LINE_FEED)
		 control=getchar();



		 //this read the string from user
		char *point=fgets(list_save_path,MAX_PATH_SIZE,stdin);

		//the fgets function have produced bad values
		if (point==NULL)
		return EXIT_FAILURE;

		//I remove from the string last char that is \n
		i=strlen(point);
		point[i-1]=0;


		if(dump_file(head,point,false)==EXIT_FAILURE)
		   return EXIT_FAILURE;
		printf("file saved as %s",point);
		}


	}
	else
		 //restore list from file
		restore_list(list,&head);

        //count test set dimensions
	line_counter(test_set,&dim_ts);
	//printf("\nTEST SET DIMENSIONS ARE %ux%u\n",dim_tr.n_rows,dim_tr.n_cols);

	//create a matrix from the test set file
	read_file(&ts_set,dim_ts,test_set);

       printf("Start testing\n");
       run_test(digit,ker,head,tr_set,dim_tr,ts_set,dim_ts,&test_error);
       printf("End testing with %f%% error\n\n\n\n",test_error*100);
       return EXIT_SUCCESS;

}


//int boost()

int voted_perceptron()
{

	v_list_head *head_pointer;

	
	printf("Training set loaded from %s\n",training_set);

	printf("Test loaded from %s\n",test_set);

	//line counter count the line in the file
       line_counter(training_set,&dim_tr);
       printf("Training set dimension are %ux%u\n",dim_tr.n_rows,dim_tr.n_cols);

       //create a matrix from the training set file
       read_file(&tr_set,dim_tr,training_set);

       //Run training 
       run_v_train(epocs,digit,tr_set,dim_tr,&head_pointer,&training_error);
       printf ("End training with %f%% error\n",training_error*100);

	v_array_element *array_pointer;  
	unsigned k;
	read_list_v(&array_pointer,head_pointer);

       //Run test
       line_counter(test_set,&dim_ts);
       printf("Test set dimension are %ux%u\n",dim_ts.n_rows,dim_ts.n_cols);
       read_file(&ts_set,dim_ts,test_set);
       run_v_test(digit,ts_set,dim_ts,head_pointer,&test_error);
       printf("End testing with %f%% error\n\n\n\n",test_error*100);
       return EXIT_SUCCESS;
}

int set_variable(const char *argument,const char *value)
{

	//Use or not adaboost
	if (!strcmp("-a",argument))
	{
		//don't use
		if (!strcmp("0",value))
		{
			adaboost=false;
			return EXIT_SUCCESS;

		}
		//use
		if (!strcmp("1",value))
		{
			adaboost=true;
			return EXIT_SUCCESS;
		}

		return EXIT_FAILURE;

	}

	if (!strcmp("-c",argument))
	{

		if (isalpha(value[0]))
		{
			return EXIT_FAILURE;
		}

		else
		{
			gaussian_c= atof(value);
			return EXIT_SUCCESS;
		}

	}

	//It recognise 1 digits as the integer that represents polinomial degree
	if (!strcmp("-d",argument))
	{

		if (isalpha(value[0]))
		{
			return EXIT_FAILURE;
		}

		else
		{
			polinomial_degree= atof(value);
			return EXIT_SUCCESS;
		}

	}
 
	//set the digit chosen
	 if (!strcmp("-dg",argument))
	{
		if (isalpha(value[0]))
			{
			return EXIT_FAILURE;
			}
		else
			{
			digit= atoi(value);
			
			if(digit>9)
				return EXIT_FAILURE;
			
			return EXIT_SUCCESS;
			}				     
	}

	//It recognise 1 digits as the integer that represents epocs
	if (!strcmp("-e",argument))
	{

	     	if (isalpha(value[0]))
	     	{
			     return EXIT_FAILURE;
		}
		     else
		     {
			     epocs= atoi(value);
			     return EXIT_SUCCESS;
		     }

	}


	//type of kernel argument
	if (!strcmp("-k",argument))
	{

		if(!strcmp("pol",value))
		{
			kernel_algoritm=polinomial;
			return EXIT_SUCCESS;
		}

		if(!strcmp("gauss",value))
		{
			kernel_algoritm=gaussian;
			return EXIT_SUCCESS;
		}
		return EXIT_FAILURE;


	}

	//path to list
	if (!strcmp("-l",argument))
	{
		//tell program to load the list next run
		load_list = true;

		//copy path from command line arg to our variable
		list = (char *)value;

		return EXIT_SUCCESS;
	}

	//set path to training set
	if (!strcmp("-tr",argument))
	{
		training_set = (char *) argument;
		return EXIT_SUCCESS;
	}

	//set path to test set
	if (!strcmp("-ts",argument))
	{
		test_set = (char *) argument;
		return EXIT_SUCCESS;
	}
	
	//Use voted
	if (!strcmp("-vot",argument))
	{
		//don't use
		if (!strcmp("0",value))
		{
			voted=false;
			return EXIT_SUCCESS;

		}
		//use
		if (!strcmp("1",value))
		{
			voted=true;
			return EXIT_SUCCESS;
		}

		return EXIT_FAILURE;

	}

}

void help(char *s)
{
	printf ("\nUsage:%s [Options]\n\n"
	"Avaiable Options: {default value}\n"
	"-a  [0|1] Use adaboost 				{no} \n"
	"-c  [0-9] Constant of gaussian kernel   	{3} \n"
	"-d  [0-9] Degree of polinomial kernel   	{2}\n"
	"-e  [0-9] Epocs of training algoritm    	{2}\n"
	"-dg [0-9] Digit to recognize			{0}\n"
	"-k  [pol||gauss] Type of kernel to use  	{polinomial} \n"
	"-l  [path/to/file] Path to saved list of previous run {no_list}\n"
	"-tr [path/to/file] Path to Training Set 	{Data/Training_set}\n"
	"-ts [path/to/file] Path to Test Set     	{Data/Test_set}\n"
	"-vot[0|1] Use voted perceptron algoritm         {no}\n\n" 
	"Wrong parameters makes this message appear\n\n",s);
}

