//voted_lib.c
#include <stdlib.h>
#include <stdbool.h>
#include "../include/list_lib.h"
#include "../include/voted_lib.h"

int run_v_train(unsigned epocs,unsigned digit,float **tr_set,struct dimension dim,v_list_head **head,t_list_head **head1,float *error)
{
	//index
	unsigned i,t,j,k;

	bool rebuild=true;

	//label from classifier
	int y_hat,label;

	//contain an array of weight
	float *help_weight;

	//array of list's elements
	v_array_element *array_pointer=NULL;

	//result of vector product
	float result;

	//pointer to a vector list head
	v_list_head  *head_pointer=NULL;

	//pointer to index list
	t_list_head *head_pointer1=NULL;

	//Create lists
	create_list_v(&head_pointer);
	create_list(&head_pointer1);

	//init an elemento to 0
	v_element element;

	//Number of errors and right classifications
	unsigned mistake=0,right=0;

	//First element is composed of all 0
	element.weight=0;
	for (i=0;i<256;++i)
	{
		element.array[i]=0;
	}


	//First vector is a 0 vector
	add_list(0,&head_pointer1);
	add_list_v(element,&head_pointer);
	read_list_v(&array_pointer,head_pointer);

	j=0;


	//start training
	for(t=0;t<epocs;++t)
	{
		//Reset mistake and right to calculate tr_error
		mistake=right=0;
	 	rebuild = true;

		//Foreach tr's element
		for(i=0;i<dim.n_rows;++i)
		{

			if (rebuild)
				read_list_v(&array_pointer,head_pointer);

			//Instead of a simple vectorial product Beniamino(the king) and his guappo Gufo
			//suggested to use a kernel function...the same used during test phase
			vect_pr((dim.n_cols-1), tr_set[i],array_pointer[j].array,&result);

			if (result<0)
				y_hat=-1;
			else
				y_hat=1;

				//If classifier is wrong
				if ((y_hat==1 && digit!=tr_set[i][dim.n_cols-1]) || (y_hat==-1 && digit==tr_set[i][dim.n_cols-1]))
				{
					//set value of label
					if (y_hat==1)
						label=-1;
					else
						label=1;

					//Update vector
					for (k=0;k<dim.n_cols-1;++k)
						element.array[k]=array_pointer[j].array[k]+(tr_set[i][k]*(float)label);

					//Set initial weight
					element.weight=1;
					//Add element to list (vk+1)
					add_list_v(element,&head_pointer);

					//Add index of element that makes our classifier fall
					add_list(i,&head_pointer1);

					rebuild=true;

					//Point to next element
					++j;
					++mistake;
				}
				//Is right
				else
				{
					rebuild=false;
					//Increase weight by 1
					(head_pointer->last->weight)+=1;
					++right;
				}
		}
		printf("ho fatto la %u-esima epoca, %u errori, %u right",t,mistake,right);
	}


	(*head)=head_pointer;
	(*head1)=head_pointer1;
	(*error)=(float)mistake/(float)dim.n_rows;
}



int run_v_test(unsigned digit,float **ts_set,struct dimension dim_ts,float **tr_set,struct dimension dim_tr,v_list_head *head_pointer,t_list_head *head_pointer1,float *error)
{
	unsigned i,j,k,mistake=0,right=0,uno=0,menouno=0;
	int y_hat,y;
	float s=0;
	float help_me=0;
	float product=0,product_help=0;

	v_array_element *array_pointer=NULL;
	t_index *array_pointer1=NULL;

	//This array is a struct's array
	read_list_v(&array_pointer,head_pointer);
	//This array contains list indexes
	read_list(&array_pointer1,head_pointer1);

	//for (j=0;j<head_pointer1->dimension;++j)
	//	printf("L'elemento %u-esimo e' un %f",j,array_pointer[j].array[255]);

	//Forech ts' element
	for (j=0;j<dim_ts.n_rows;++j)
	{
		//Foreach list element
		for (i=0;i<(head_pointer->dimension);++i)
		{

			if ((tr_set [array_pointer1[i]] [dim_tr.n_cols-1])==(float)digit)
				y=1;
			else
				y=-1;

			//as before we want some more precise algoritm
			help_me=0;
			vect_pr((dim_ts.n_cols-1), ts_set[j],array_pointer[i].array,&help_me);

/*			//the first one is a zero vector
			if(i==0)
			{

				product=0;
			}
			else
			{

				product=0;
				product_help=0;

				//Product must happen 2 times or result is nan!
				//we're using gcc 3.2.3 and gcc 3.3.1
				
				for(k=0;k<256;++k)
				{
					product_help = product_help + (ts_set[j][k] * array_pointer[i-1].array[k]);


				}

				for(k=0;k<256;++k)
				{
					product = product + (ts_set[j][k] * array_pointer[i-1].array[k]);

				}

				//vect_product((dim_ts.n_cols-1),ts_set[j],array_pointer[i-1].array,&product);
			}


			//printf ("Product vale %f ",product);
			help_me+=product;
*/
			help_me*=(float)y;

			if (help_me>0)
				y_hat=1;
			else
				y_hat=-1;

			s+= ((float)y_hat*(float)(array_pointer[i].weight));

		}
		/*printf ("S vale %f",s);
		getchar();*/
		//Classify
		if (s<0)
		{
			++menouno;
			y_hat=-1;
		}
		else
		{
			++uno;
			y_hat=1;
		}
	
			
		if ((y_hat==1 && digit!=ts_set[j][dim_ts.n_cols-1]) || (y_hat==-1 && digit==ts_set[j][dim_ts.n_cols-1]))
			++mistake;
		else
			++right;
	
		//Reset classifier result
		s=0;
	}
				
	printf ("Ho classificato la cifra %u e ho azzeccato %u volte e sbagliato %u volte, ho detto %u volte meno e %u volte piu'\n",digit,right,mistake,menouno,uno);
	(*error)=((float)mistake/(float)dim_ts.n_rows);

}

vect_v_pr(unsigned int dimension,float *X,float *Xi,float *result)
{
	//initialization of result value, or it will go to infinity in a cuple loop
	(*result)=0;
	float pippo=0;	
int i;	

//	for(i=0 ; i<256;++i)
//		printf("x vale %f e xi vale %f",X[i],Xi[i]);

//	scanf("%d",&i);
	//we calculate the product of 2 vectors
	vect_pr(dimension,X,Xi,&pippo);
//printf("la vect pr fornisce %f",pippo);
//scanf("%d",&i);
	//Increment it by 1
	++pippo;

	//raise it to the power of "degree"
	pippo = powf (pippo, 9);
	
//printf("la powf fornisce pr fornisce %f",pippo);
//scanf("%d",&i);
	(*result)=pippo;
	
	//printf ("%f  \n  ",pippo);
	
	return EXIT_SUCCESS;
	
}

int vect_product(unsigned int dimension,float *vect1,float *vect2,float *result)
{
	unsigned int i;
static unsigned j=0;
	//initialization of result value, or it will go to infinity in a cuple loop
	float help=0;

	printf ("il prodotto  di %f %f la %u-esima volta\n",vect1[255],vect2[255],j);
	printf ("result %f", help);
	getchar();
	//last element is the label!!be careful
	for(i=0;i<256;++i)
	{
		help += (vect1[i] * vect2[i]);
		printf("result %f  vect1 %f  vect2 %f\n ",help,vect1[i],vect2[i]);
	}

	(*result)=help;
	getchar();
	j++;
	return EXIT_SUCCESS;
	
}
