//perceptron_lib.h
#ifndef _PERCEPTRON_LIB_H

#define _PERCEPTRON_LIB_H 1

#include "list_lib.h"
#include <stdbool.h>
#include "file_lib.h"

typedef enum kernel_set t_kernel;
enum kernel_set {polinomial,gaussian};

struct kernel_record
{
t_kernel kernel_function;
float parameter;
};

//calculate the norm of each "col" elements of matrix pointed by matrix_pointer and put it onto norma array
int calc_norma (unsigned int elements, unsigned int col,float **matrix_pointer,float **norma);
//calculate the vectorial product of two arrays of "dimension" elements
int vect_pr(unsigned int dimension, float *vect1,float *vect2,float *result);
//calculate the vectorial difference between 2 arrays raised 2
int vect_diff_raised(unsigned int dimension,float *vect1,float *vect2,float *result);
//calculate polinomial kernel value of 2 elements with "degree" specified. Elements are composed of "dimension" fields
int ker_pol(unsigned int dimension,float *vect11,float *vect2,float *result,float degree);
//the gaussian kernel function between two vector and with a constant
int ker_gauss(unsigned int dimension,float *vect1,float *vect2,float *result,float constant);
//Number of epocs, what digit we have to classify, with which kernel, a pointer to an index's list pointer, the matrix generated by read_file, with dimensions specified in dim struct
int run(unsigned int epocs,unsigned int digit,struct kernel_record ker,t_list_head **head,float **matrix,struct dimension dim,float *training_error);

int run_test(unsigned int digit,struct kernel_record ker,t_list_head *head,float **tr_set,struct dimension dim_tr,float **ts_set,struct dimension dim_ts,float *test_error);

//What kernel use, what's the digit to recognise, 2 element (Xt) and elements from the big matrix(**matrix)to  compare with Xt (the one included into the list )
int classify(struct kernel_record ker,unsigned int digit,float *Xt,float **matrix,struct dimension dim,t_index *array_pointer,unsigned int arr_dim,int *result);
#endif
