//file_lib.c
#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include "../include/file_lib.h"

int read_file(float ***matrix,struct dimension dim,const char *path)
{
	FILE *id;
	unsigned int count,i=0,j=0;


	// this produce errors if the file doesn't exists
	if ((id=fopen(path,"r"))==NULL)
		{
			printf("ERRORE NEL FILE");
			return EXIT_FAILURE;
		}

        //Here create the matrix
	(*matrix)=malloc(sizeof(float *) * dim.n_rows);

	for(;i<(dim.n_rows);++i)
		(*matrix)[i]=malloc(sizeof(float) * (dim.n_cols));


	//Here we populate the Matrix
	i=0;
        while( i<(dim.n_rows))
	{
	count=fscanf(id,"%f",&(*matrix)[i][j]);
	if (count != 1)
		return EXIT_FAILURE;
	
	++j;
		if(j==dim.n_cols)
		{
			++i;
			j=0;

		}
	
	}	
       
	return EXIT_SUCCESS;
}

int line_counter(const char *path,struct dimension *dim)
{
	int i=sizeof(char);	
	unsigned int l=0, c=0, flag=0;
	unsigned char read_buffer;

	//here we open the file on read mode
	int fd=open(path,0);
	
	//here we count the LF (line feed) contained in file
	while(i==sizeof(unsigned char))
	{
		i=read(fd,&read_buffer,sizeof(unsigned char));
		if (read_buffer==LINE_FEED)
			++l;//Increment line number

		if (read_buffer!=SPACE)
			flag=0;
		//Count entries of the first row
		if (l==0 && read_buffer==32 && flag==0)
		{
			++c;
			flag=1; //sequence of spaces doesn't matter
		}
	}
	dim->n_rows=--l;//it recognise EOF as a LF (os something similar) so we need to puts our hand on :-)
	dim->n_cols=++c;//it doesn't count the first one
	close(fd);

	return EXIT_SUCCESS;
}

int dump_file(t_list_head *head_pointer,const char *file,bool remove)
{
	
	t_index *array_pointer=NULL;
        int i; 
	
	//create array of list's elements
	if (read_list(&array_pointer,head_pointer)==-1)
		return EXIT_FAILURE;
	
	//Create file specified, overwriting (if exists) the old one
	FILE *ptr_file=fopen(file,"w");
	for (i=0;i<head_pointer->dimension;++i)
	{	
		
        	//element
		fprintf(ptr_file,"%u",array_pointer[i]);
		//LineFeed
		fprintf(ptr_file,"%c",10);
	
	}
	fclose(ptr_file);

	if (remove)
	{
		del_list(head_pointer);
	}
}
int restore_list(const char *path,t_list_head **head)
{
	
	FILE *ptr_file=fopen(path,"r");
	unsigned int count=1;
	t_index help;
	
	create_list(head);
	while(count==fscanf(ptr_file,"%u",&help) )

	{
		add_list(help,head);
	}
	return EXIT_SUCCESS;
}


