//list_lib.c
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include "../include/list_lib.h"


int create_list(t_list_head  **head_pointer)
{
	//Create a pointer to struct's space in memory 
	*head_pointer= (t_list_head *) malloc(sizeof(t_list_head));
	if (*head_pointer == NULL) //If something goes wrong
		return -1;
	
	(*head_pointer)->first = NULL;
	(*head_pointer)->last = NULL;
	(*head_pointer)->dimension= 0;
	return EXIT_SUCCESS;	
}

int add_list (t_index index,t_list_head **head_pointer)
{
	if ((*head_pointer)==NULL) //If pointer is wrong
		return -1;
	
	if ((*head_pointer)->first==NULL)
 	{		
		//Create the first element
		t_element *first;
		first = (t_element *) malloc(sizeof(t_element));
		first->index=index;
		first->next=NULL;
		(*head_pointer)->first = (*head_pointer)->last = first;
		//Set the list dimension
		(*head_pointer)->dimension=1;
		return EXIT_SUCCESS;
	}
	
	else
	{
		//Create a new element
		struct element *last;
		last = (t_element *) malloc(sizeof(t_element));
		last->index = index;
		last->next = NULL;
		//Field "last" of head_pointer has address of last element -> update his "next" field 
		((*head_pointer)->last)->next = last;
		//This element is the last
		(*head_pointer)->last=last;
		//Increment list's dimension
		(*head_pointer)->dimension=(*head_pointer)->dimension + 1;
		return EXIT_SUCCESS;
	}
}
int read_list(t_index **array_pointer,t_list_head *head_pointer)
{       
	//Bad arguments
        if( head_pointer==NULL )
          	return -1;

	if( head_pointer->dimension==0)
	{
		(*array_pointer)=NULL;
	  	return EXIT_SUCCESS;
	}

	//Create an array of list's elements
	
	//The first time do nothing
	if ((head_pointer->dimension)!=1)
		free (*array_pointer);
	                       
	(*array_pointer) = (t_index *) malloc(sizeof(t_index) * (head_pointer->dimension));

	//Cycle elements of the list and populate the array
	t_element *tmp_pointer;
	int i;

	tmp_pointer=(head_pointer->first);

	for(i=0;tmp_pointer != NULL;++i)
	{
		(*array_pointer)[i] = (tmp_pointer->index);
		tmp_pointer=(tmp_pointer->next);
	}
	return EXIT_SUCCESS;
}

int del_list(t_list_head *head)
{
	t_element *service,*free_me=head->first;
	while(free_me!=NULL)
	{
		service=(free_me->next);
		if (service == NULL)
		{
			free(free_me);
			break;
		}
		free_me=service;
	
	}
	free(head);
	return EXIT_SUCCESS;
}
