//perceptron_lib.c
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdbool.h>
#include "../include/perceptron_lib.h"
#include "../include/list_lib.h"

int calc_norma (unsigned int elements, unsigned int col,float **matrix_pointer,float **norma)
{
	int i,j;
	i=j=0;
	float help_me_im_getting_mad,help;
	
	//create space for norma_array in memory
	(*norma) = (float *) malloc (sizeof (float) * elements);


	
	for (i;i<elements;++i)
	{
		for (j=0;j<col;++j)
			(*norma)[i] += (powf ((matrix_pointer[i][j]),2.00));//sum of square
	
	help_me_im_getting_mad = sqrtf((*norma)[i]);//square root of norma
	(*norma)[i]=help_me_im_getting_mad;
	}
	return EXIT_SUCCESS;
}

int vect_pr(unsigned int dimension,float *vect1,float *vect2,float *result)
{
	unsigned int i;

	//initialization of result value, or it will go to infinity in a cuple loop
	(*result)=0;

	//last element is the label!!be careful
	for(i=0;i<dimension;++i)
	{
		(*result) += (vect1[i] * vect2[i]);
	}
	return EXIT_SUCCESS;
}

int vect_diff_raised(unsigned int dimension,float *vect1,float *vect2,float *result)
{
	float help;
	unsigned i;
	for(i=0;i<dimension;++i)
		help+=powf((vect1[i]-vect2[i]),2);

	(*result)=help;


	return EXIT_SUCCESS;
}

int ker_pol(unsigned int dimension,float *vect1,float *vect2,float *result,float degree)
{

	printf ("Arg %u %f %f %f %f",dimension,vect1[256],vect2[256],result,degree);
	//we calculate the product of 2 vectors
	vect_pr(dimension,vect1,vect2,result);

	//Increment it by 1
	++(*result);

	//raise it to the power of "degree"
	(*result) = powf ((*result), degree);
	printf ("result vale %f",result);
	getchar();

	return EXIT_SUCCESS;
}

int ker_gauss(unsigned int dimension,float *vect1,float *vect2,float *result,float constant)
{
	float help=0;

	//execute the vector difference
	vect_diff_raised( dimension,vect1,vect2,&help);

	//execute the gaussian kernel function
	(*result)=expf (-help/constant);

	return EXIT_SUCCESS;
}

int classify(struct kernel_record ker,unsigned int digit,float *Xt,float **matrix,struct dimension dim,t_index *array_pointer,unsigned int arr_dim,int *result)
{

        t_kernel kernel=ker.kernel_function;
         float parameter=ker.parameter;
	unsigned int k;
	int y_tk;

	float *Xtk,ker_result;
	float help_me_please=0;


	//Foreach element of the list (Xtk)
	for(k=0;k<(arr_dim);++k)
	{
		Xtk = matrix [ array_pointer[k] ];



		//Evaluate the label (PAY ATTENTION TO INDEXES!!!)
		if (Xtk[dim.n_cols-1] == digit)
			y_tk=1;
		else
			y_tk=-1;


		switch (kernel)
		{
			case polinomial:
				ker_pol((dim.n_cols-1),Xt,Xtk,&ker_result,parameter);
				break;
			case gaussian:
			        ker_gauss((dim.n_cols-1),Xt,Xtk,&ker_result,parameter);
				break;
		}

		//Classify this image (Calculate y_hat)
		help_me_please += (y_tk * ker_result);

	}
	if (help_me_please<0)
		(*result) = -1;
	else
		(*result)=1;

}

int run(unsigned int epocs,unsigned int digit,struct kernel_record ker,t_list_head **head,float **matrix,struct dimension dim,float *training_error)
{
        //When list is modified we need to repopulate the array
        bool rebuild = true;
	//Counter
	unsigned int uno,menouno;
	uno=menouno=0;
	//Indexes
        t_index i,j;

	//Result of the classifier
	int y_hat;
	int y_t;

        t_index *array_pointer;
	float *Xt;

	unsigned int mistake,right,mistake_save;
	mistake=right=0;

	//Unico controllo (inutile) del valore di ritorno della funzione _TODO:REMOVE THIS LINE_
	if (create_list (head)==-1)
		return EXIT_FAILURE;

	for(i=0;i<epocs;++i)
	{
		//Foreach element Xt of the matrix
		for(j=0;j<dim.n_rows;++j)
		{
			//Set Xt & Y_t
			Xt = matrix[j];

			//Be careful with indexes!!!
			if (Xt[dim.n_cols-1] == digit)
				y_t=1;
			else
				y_t=-1;

			//If list is empty
			if ((*head)->first==NULL)
				y_hat=1;

			else
			{
				//if it was modified repopulate the array of Ytk
				if (rebuild)
				read_list(&array_pointer,(*head));

 				classify(ker,digit,Xt,matrix,dim,array_pointer,(*head)->dimension,&y_hat);
			}

			if (y_hat==1)
				++uno;
			else
				++menouno;
			if (y_hat != y_t)
			{
				//foreach element that makes classifier fall  add it to the list
				add_list(j,head);
				rebuild = true;
				++mistake;
			}
			else
			{
				rebuild = false;
				++right;
			}

		}//End foreach Xt

		printf ("I classified %u times 1 e %u times -1\n",uno,menouno);
		
		//save the value
		mistake_save=mistake;
		//Our counters must be resetted
		uno = menouno = mistake = right = 0;
		//Before starting an epoc rebuild the table (or it segfaults :-))
		rebuild = true;
		
	}//End epocs
	//here calculate the training error
	
	(*training_error)=((float)mistake_save)/((float)dim.n_rows);
	
}
int run_test(unsigned int digit,struct kernel_record ker,t_list_head *head,float **tr_set,struct dimension dim_tr,float **ts_set,struct dimension dim_ts,float *test_error)
{




	//Counter
	unsigned int uno,menouno,unomi,menounomi;
	uno=menouno=unomi=menounomi=0;
	//Indexes
        t_index i,j;

	//Result of the classifier
	int y_hat;
	int y_t;


	t_index *array_pointer;

	float *Xt;

	unsigned int mistake,right;
	mistake=right=0;

			//If list is empty
			if (head->first==NULL)
			{
				return EXIT_FAILURE;
			}


	read_list(&array_pointer,head);
		//Foreach element Xt of the training set
		for(j=0;j<dim_ts.n_rows;++j)
		{
			//Set Xt & Y_t
			Xt = ts_set[j];
			



			
			//Be careful with indexes!!!
			if (Xt[dim_ts.n_cols-1] == digit)
				y_t=1;
			else
				y_t=-1;




 				classify(ker,digit,Xt,tr_set,dim_tr,array_pointer,head->dimension,&y_hat);


			if (y_hat==1)
				++uno;
			else if(y_hat==-1)
				++menouno;
			
			if (y_hat != y_t)
			{
				//foreach element that makes classifier fall  add it to the list
				++mistake;
				if (y_hat==1)
					++unomi;
				else
					++menounomi;
			}
			else
			{
				++right;
			}

		}//End foreach Xt
//calulate the test error
 (*test_error)=((float)mistake)/((float)dim_tr.n_rows);

	printf ("I classified %u times 1 e %u times -1\n",uno,menouno);
	printf ("I was wrong %u times saying 1 e %u times saying -1\n",unomi,menounomi);
		
}
