//voted_lib_ker.c
#include <stdlib.h>
#include <stdbool.h>
#include "../include/list_lib.h"
#include "../include/voted_lib.h"
#include "../include/voted_lib_ker.h"

int run_v_train_ker(unsigned epocs,unsigned digit,float **tr_set,struct dimension dim,t_index **array_x,unsigned **voti,unsigned *number,float *error)
{
	//index
	unsigned i,t,j,k;
	
	bool rebuild=true;

	//label from classifier
	int y_hat,label;

	//contain an array of weight
	float *help_weight;

	//array of list's elements
	v_array_element *array_pointer=NULL;

	//result of vector product
	float result;

	//pointer to a vector list head
	v_list_head  *head_pointer=NULL;
	t_list_head *head_pointer1;

	//Create lists
	create_list_v(&head_pointer);
	create_list(&head_pointer1);

	//init an elemento to 0
	v_element element;

	//Number of errors and right classifications
	unsigned mistake=0,right=0;

	//First element is composed of all 0
	element.weight=0;
	for (i=0;i<256;++i)
	{
		element.array[i]=0;
	}


	//First vector is a 0 vector
	add_list_v(element,&head_pointer);
	read_list_v(&array_pointer,head_pointer);

	j=0;


	//start training
	for(t=0;t<epocs;++t)
	{
		//Reset mistake and right to calculate tr_error
		mistake=right=0;
	 	rebuild = true;

		//Foreach tr's element
		for(i=0;i<dim.n_rows;++i)
		{

			if (rebuild)
				read_list_v(&array_pointer,head_pointer);

			//Instead of a simple vectorial product Beniamino(the king) and his guappo Gufo
			//suggested to use a kernel function...the same used during test phase
			vect_pr((dim.n_cols-1), tr_set[i],array_pointer[j].array,&result);

			if (result<0)
				y_hat=-1;
			else
				y_hat=1;

				//If classifier is wrong
				if ((y_hat==1 && digit!=tr_set[i][dim.n_cols-1]) || (y_hat==-1 && digit==tr_set[i][dim.n_cols-1]))
				{
					//set value of label
					if (y_hat==1)
						label=-1;
					else
						label=1;

					//Update vector
					for (k=0;k<dim.n_cols-1;++k)
						element.array[k]=array_pointer[j].array[k]+(tr_set[i][k]*(float)label);

					//Set initial weight
					element.weight=1;
					//Add element to list (vk+1)
					add_list_v(element,&head_pointer);
					add_list(i,&head_pointer1);

					rebuild=true;

					//Point to next element
					++j;
					++mistake;
				}
				//Is right
				else
				{
					rebuild=false;
					//Increase weight by 1
					(head_pointer->last->weight)+=1;
					++right;
				}
		}
		printf("ho fatto la %u-esima epoca, %u errori, %u right",t,mistake,right);
	}


	//Create classifier in terms of array of elements from training set
	read_list(array_x,head_pointer1);

	
	//Return weights
	(*voti)=(unsigned *)malloc (sizeof (unsigned) * head_pointer->dimension);
	read_list_v(&array_pointer,head_pointer);
	
	//First element isn't important
	for (i=1;i<head_pointer->dimension;++i)
		(*voti)[i-1]=array_pointer[i].weight;
	
	//Return element's number
	(*number)=head_pointer1->dimension;
	
	(*error)=(float)mistake/(float)dim.n_rows;
}



int run_v_test_ker(unsigned digit,float **ts_set,struct dimension dim_ts,float **tr_set,struct dimension dim_tr,unsigned *array_x,unsigned *weight,unsigned dim_array,float *error)
{
	unsigned i,j,k,mistake=0,right=0,uno=0,menouno=0;
	float y,y_hat;
	float help=0;
	int s=0,y_;
	
	//Forech ts' element
	for (j=0;j<dim_ts.n_rows;++j)
	{

		//Classify elelement

		//Foreach list element
		for(i=0;i<dim_array;++i)
		{
			//Set label
			if(tr_set[ array_x[i] ] [dim_tr.n_cols-1]==(float)digit)
				y=1.0;
			else
				y=-1.0;
			
			kernel_pol((dim_ts.n_cols-1), ts_set[j], (tr_set[array_x[i]]), &help,3); 
	//		printf ("Help prima %f \n",help);
			help *= y;
	//		printf("Help dopo %f \n",help);
			if (help>0.0)
				y_hat = 1.0;
			else
				y_hat = -1.0;
			
			if (help>0.0)
				y_ = 1;
			else
				y_ = -1;
			
			s += (y_ * (int) weight[i] );
			
	//		printf ("S vale %d e help invece %f y %f e y_hat %d il peso %u\n\n\n\n",s,help,y,y_,weight[i]);
	//		getchar();
		}
	
		
		
		//printf ("S vale %d",s);
		//getchar();
		
		
		//Classify
		if (s<0)
		{
			++menouno;
			y_hat=-1;
		}
		else
		{
			++uno;
			y_hat=1;
		}
	
			
		if ((y_hat==1 && digit!=ts_set[j][dim_ts.n_cols-1]) || (y_hat==-1 && digit==ts_set[j][dim_ts.n_cols-1]))
			++mistake;
		else
			++right;
	
		//Reset classifier result
		s=0;
	}
				
	printf ("Ho classificato la cifra %u e ho azzeccato %u volte e sbagliato %u volte, ho detto %u volte meno e %u volte piu'\n",digit,right,mistake,menouno,uno);
	(*error)=((float)mistake/(float)dim_ts.n_rows);

}

int kernel_pol(unsigned int dimension,float *vect1,float *vect2,float *result,unsigned degree)
{

	float product_help=0,product=0;
	unsigned k;
	
	(*result)=0;
	//we calculate the product of 2 vectors
	for(k=0;k<256;++k)
	{
		product_help = product_help + (vect1[k] * vect2[k]) ;
		product = product + (vect1[k] * vect2[k]); 
	}

	//Increment it by 1
	++product;

	//raise it to the power of "degree"
	(*result) = powf (product,(float) degree);
	return EXIT_SUCCESS;
}

