//voted_list_lib.c

#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include "../include/voted_list_lib.h"


int create_list_v(v_list_head  **head_pointer)
{
	//Create a pointer to struct's space in memory 
	*head_pointer= (v_list_head *) malloc(sizeof(v_list_head));
	if (*head_pointer == NULL) //If something goes wrong
		return -1;
	
	(*head_pointer)->first = NULL;
	(*head_pointer)->last = NULL;
	(*head_pointer)->dimension= 0;
	return EXIT_SUCCESS;	
}

int add_list_v(v_element elem,v_list_head **head_pointer)
{
	int i;
	if ((*head_pointer)==NULL) //If pointer is wrong
		return -1;
	
	if ((*head_pointer)->first==NULL)
 	{		
		//Create the first element
		v_element *first;
		first = (v_element *) malloc(sizeof(v_element));
		
		for(i=0;i<256;++i)
			first->array[i]=elem.array[i];
		
		first->weight = elem.weight;
		first->next=NULL;
		(*head_pointer)->first = (*head_pointer)->last = first;
		//Set the list dimension
		(*head_pointer)->dimension=1;
		return EXIT_SUCCESS;
	}
	
	else
	{
		//Create a new element
		v_element *last;
		last = (v_element *) malloc(sizeof(v_element));
		
		for(i=0;i<256;++i)
			last->array[i]=elem.array[i];

		last->weight = elem.weight;
		last->next = NULL;
		//Field "last" of head_pointer has address of last element -> update his "next" field 
		((*head_pointer)->last)->next = last;
		//This element is the last
		(*head_pointer)->last=last;
		//Increment list's dimension
		(*head_pointer)->dimension=(*head_pointer)->dimension + 1;
		return EXIT_SUCCESS;
	}
}

int read_list_v(v_array_element **array_pointer,v_list_head *head_pointer)
{       
	//Bad arguments
        if( head_pointer==NULL )
          	return -1;

	//If is empty
	if( head_pointer->dimension==0)
	{
		(*array_pointer)=NULL;
	  	return EXIT_SUCCESS;
	}

	
	//The first time do nothing 
	if ((head_pointer->dimension)!=1)
		free (*array_pointer);
	
	(*array_pointer) =  malloc (sizeof(v_element) * (head_pointer->dimension));
	
	//Cycle elements of the list and populate the array
	v_element *tmp_pointer;
	int i,j;

	tmp_pointer=(head_pointer->first);

	for(i=0;tmp_pointer != NULL;++i)
	{	

		(*array_pointer)[i].array = tmp_pointer->array;
		(*array_pointer)[i].weight = tmp_pointer->weight;	
		tmp_pointer=(tmp_pointer->next);
	}
	return EXIT_SUCCESS;
}

int del_list_v(v_list_head *head)
{
	v_element *service,*free_me=head->first;
	while(free_me!=NULL)
	{
		service=(free_me->next);
		if (service == NULL)
		{
			free(free_me);
			break;
		}
		free_me=service;
	
	}
	free(head);
	return EXIT_SUCCESS;
}
